class Sequence
  include Enumerable

  def initialize(*arr, &blk)
    @arr = arr
    @blk = blk
  end

  def each
    idx = 0
    while true
      if @arr.size-1 < idx
	@blk.call(@arr, idx)
      end
      yield(@arr[idx])
      idx += 1
    end
  end

  def [](n)
    r = nil
    each_with_index { |r, i| break if i == n }
    r
  end
end

puts "Factorials"
fact = Sequence.new(1) { |a, i| a[i] = i*a[i-1]}
fact.each_with_index { |n, i| break if i > 10; printf "%2d %20d\n", i, n }
puts fact[100]

puts
puts "Fibonacci Numbers"
fib = Sequence.new(0, 1) { |a, i| a[i] = a[i-1]+a[i-2] }
fib.each_with_index { |n, i| break if i > 10; printf "%2d %20d\n", i, n }
puts fib[100]
